#include "FrSkySPort.h"

#define _FrSkySPort_Serial            Serial1
#define _FrSkySPort_C1                UART0_C1
#define _FrSkySPort_C3                UART0_C3
#define _FrSkySPort_S2                UART0_S2
#define _FrSkySPort_BAUD           57600
#define   MAX_ID_COUNT              19

short crc;                         // used for crc calc of frsky-packet
uint8_t lastRx;
uint32_t FR_ID_count = 0;
uint8_t cell_count = 0;
uint8_t latlong_flag = 0;
uint32_t latlong = 0;
uint8_t first=0;

// POUR TEST 
int32_t    ap_latitude = 0;              // 585522540;
int32_t    ap_longitude = 0;            // 162344467;
int32_t    ap_gps_altitude = 0;        // 1000 = 1m


// ***********************************************************************
void FrSkySPort_Init(void)  {
      _FrSkySPort_Serial.begin(_FrSkySPort_BAUD);
      _FrSkySPort_C3 = 0x10;            // Tx invert
      _FrSkySPort_C1= 0xA0;            // Single wire mode
      _FrSkySPort_S2 = 0x10;           // Rx Invert
      
}

// ***********************************************************************
void FrSkySPort_Process(void) {
	uint8_t data = 0;
        uint32_t temp=0;
	uint8_t offset;
        while ( _FrSkySPort_Serial.available()) 
          {
	  data =  _FrSkySPort_Serial.read();
          if (lastRx == START_STOP && ((data == SENSOR_ID1) || (data == SENSOR_ID2) || (data == SENSOR_ID3)  || (data == SENSOR_ID4))) 
            {
             
              switch(FR_ID_count) {
                 case 0:
                   FrSkySPort_SendPackage(FR_ID_ALTITUDE,NazaCanDecoder.getAlt() * 100 );  // ALTITUDE ####################################################
                 break;
                 case 1:
                 
                 FrSkySPort_SendPackage(FR_ID_T2 ,NazaCanDecoder.getNumSat()*10 + NazaCanDecoder.getFixType());
                 break;
/*                 
switch (NazaCanDecoder.getFixType())
    {
      case NazaCanDecoderLib::NO_FIX:   FrSkySPort_SendPackage(FR_ID_T2,0 ); break;
      case NazaCanDecoderLib::FIX_2D:   FrSkySPort_SendPackage(FR_ID_T2,2 ); break;
      case NazaCanDecoderLib::FIX_3D:   FrSkySPort_SendPackage(FR_ID_T2,3 ); break;
      case NazaCanDecoderLib::FIX_DGPS: FrSkySPort_SendPackage(FR_ID_T2,4 ); break;
      default:                          FrSkySPort_SendPackage(FR_ID_T2,99 );
    }
                 break;
*/    
                 case 2:
                   FrSkySPort_SendPackage(FR_ID_GPS_ALT,NazaCanDecoder.getGpsAlt()*100);           
                 break;  
                 
                 case 3:
                   FrSkySPort_SendPackage(FR_ID_VFAS,NazaCanDecoder.getBattery() /10);           
                 break;

                case 4:        // Sends the ap_longitude value, setting bit 31 high
                //ap_longitude = abs(NazaCanDecoder.getLon()*10000000);
                ap_longitude = NazaCanDecoder.getLon()*10000000;
                //ap_longitude = 25432100; 
                       if(ap_longitude < 0)
                           latlong=((abs(ap_longitude)/100)*6)  | 0xC0000000;
                           else
                           latlong=((abs(ap_longitude)/100)*6)  | 0x80000000;
                       FrSkySPort_SendPackage(FR_ID_LATLONG,latlong);
                       
                   break;
                   
                 case 5:        // Sends the ap_latitude value, setting bit 31 low  
                 //ap_latitude = abs(NazaCanDecoder.getLat()*10000000);
                 ap_latitude = NazaCanDecoder.getLat()*10000000;
                 //ap_latitude =481234500;
                         if(ap_latitude < 0 )
                             latlong=((abs(ap_latitude)/100)*6) | 0x40000000;
                             else
                             latlong=((abs(ap_latitude)/100)*6);
                         FrSkySPort_SendPackage(FR_ID_LATLONG,latlong);
                         
                    break;  
                    
                    
                    
                    
                    
                 case 6:
                   FrSkySPort_SendPackage(FR_ID_HEADING,NazaCanDecoder.getHeading()*100 );           
                 break;                     
                    
                    
     
                      case 7:
switch (NazaCanDecoder.getMode())
    {
      case NazaCanDecoderLib::MANUAL:   FrSkySPort_SendPackage(FR_ID_T1,0 ); break;
      case NazaCanDecoderLib::ATTI:     FrSkySPort_SendPackage(FR_ID_T1,1 ); break;
      case NazaCanDecoderLib::GPS:      FrSkySPort_SendPackage(FR_ID_T1,2 ); break;
      case NazaCanDecoderLib::FAILSAFE: FrSkySPort_SendPackage(FR_ID_T1,3 ); break;

      default:                          FrSkySPort_SendPackage(FR_ID_T1,99 ); 
    }    
               break;                 
               
               
               case 8:               
               
               FrSkySPort_SendPackage(FR_ID_FUEL,NazaCanDecoder.getCog() ); break;
               
               case 9:               
               
               //FrSkySPort_SendPackage(FR_ID_SPEED,NazaCanDecoder.getSpeed() *100 ); break;
               FrSkySPort_SendPackage(FR_ID_RPM,NazaCanDecoder.getSpeed() *2 *100); break;
               case 10:               
               
               FrSkySPort_SendPackage(FR_ID_VARIO,NazaCanDecoder.getVsi()*100 ); break;  
    
               case 11:               
               
               FrSkySPort_SendPackage(FR_ID_ACCZ,NazaCanDecoder.getHdop()*100 ); break;           
               
               case 12:               
               
               FrSkySPort_SendPackage(FR_ID_ACCX,NazaCanDecoder.getRoll()*100 ); break;              
               
               case 13:               
               
               FrSkySPort_SendPackage(FR_ID_ACCY,NazaCanDecoder.getPitch() *100); break;
               
               
                 
                 
               }
            FR_ID_count++;
            if(FR_ID_count > MAX_ID_COUNT) FR_ID_count = 0;  
            }
          lastRx=data;
          }
}


   // ***********************************************************************
    void FrSkySPort_SendByte(uint8_t byte) {

       if (( byte == START_STOP ) || ( byte == BYTESTUFF )) {
          _FrSkySPort_Serial.write(BYTESTUFF) ;
          _FrSkySPort_Serial.write(byte ^ STUFF_MASK) ;
       } else {
          _FrSkySPort_Serial.write(byte) ;
       }
      
            // CRC update
       crc += byte;         //0-1FE -> commentaire adéquat
       crc += crc >> 8;   //0-1FF -> commentaire adéquat
       crc &= 0x00ff;      // 0-0FF -> commentaire adéquat
    }


    // ***********************************************************************
    void FrSkySPort_SendCrc() {
      //  _FrSkySPort_Serial.write(0xFF-crc);
      crc = 0xFF-crc ;
      if (( crc  == START_STOP ) || ( crc  == BYTESTUFF )) {
         _FrSkySPort_Serial.write(BYTESTUFF) ;
         _FrSkySPort_Serial.write(crc  ^ STUFF_MASK) ;
      }else {
         _FrSkySPort_Serial.write(crc ) ;
      }

      crc = 0;          // CRC reset
    }







/*
// ***********************************************************************
void FrSkySPort_SendByte(uint8_t byte) {
	
       _FrSkySPort_Serial.write(byte);
	
        // CRC update
	crc += byte;         //0-1FF
	crc += crc >> 8;   //0-100
	crc &= 0x00ff;
	crc += crc >> 8;   //0-0FF
	crc &= 0x00ff;
}


// ***********************************************************************
void FrSkySPort_SendCrc() {
	_FrSkySPort_Serial.write(0xFF-crc);
        crc = 0;          // CRC reset
}
*/

// ***********************************************************************
void FrSkySPort_SendPackage(uint16_t id, uint32_t value) {
             
//	if(MavLink_Connected) {
        if (1==1) {
            
            }
            
        digitalWrite(led,HIGH);    
        _FrSkySPort_C3 |= 32;      //  Transmit direction, to S.Port
	FrSkySPort_SendByte(DATA_FRAME);
	uint8_t *bytes = (uint8_t*)&id;
	FrSkySPort_SendByte(bytes[0]);
	FrSkySPort_SendByte(bytes[1]);
	bytes = (uint8_t*)&value;
	FrSkySPort_SendByte(bytes[0]);
	FrSkySPort_SendByte(bytes[1]);
	FrSkySPort_SendByte(bytes[2]);
	FrSkySPort_SendByte(bytes[3]);
	FrSkySPort_SendCrc();
	_FrSkySPort_Serial.flush();
	_FrSkySPort_C3 ^= 32;      // Transmit direction, from S.Port

        digitalWrite(led,LOW);
        
}
